org.apache.commons.lang3.builder

## Class HashCodeBuilder

- java.lang.Object
- - org.apache.commons.lang3.builder.HashCodeBuilder

- All Implemented Interfaces:
    Builder<Integer>

      public class HashCodeBuilder
      extends Object
      implements Builder<Integer>

  Assists in implementing `Object.hashCode()` methods.

  This class enables a good `hashCode` method to be built for any class. It follows the rules laid out in the book Effective Java by Joshua Bloch. Writing a good `hashCode` method is actually quite difficult. This class aims to simplify the process.

  The following is the approach taken. When appending a data field, the current total is multiplied by the multiplier then a relevant value for that data type is added. For example, if the current hashCode is 17, and the multiplier is 37, then appending the integer 45 will create a hash code of 674, namely 17 * 37 + 45.

  All relevant fields from the object should be included in the `hashCode` method. Derived fields may be excluded. In general, any field used in the `equals` method must be used in the `hashCode` method.

  To use this class write code as follows:

       public class Person {
         String name;
         int age;
         boolean smoker;
         ...

         public int hashCode() {
           // you pick a hard-coded, randomly chosen, non-zero, odd number
           // ideally different for each class
           return new HashCodeBuilder(17, 37).
             append(name).
             append(age).
             append(smoker).
             toHashCode();
         }
       }

  If required, the superclass `hashCode()` can be added using `appendSuper(int)`.

  Alternatively, there is a method that uses reflection to determine the fields to test. Because these fields are usually private, the method, `reflectionHashCode`, uses `AccessibleObject.setAccessible` to change the visibility of the fields. This will fail under a security manager, unless the appropriate permissions are set up correctly. It is also slower than testing explicitly.

  A typical invocation for this method would look like:

       public int hashCode() {
         return HashCodeBuilder.reflectionHashCode(this);
       }

  The `HashCodeExclude` annotation can be used to exclude fields from being used by the `reflectionHashCode` methods.

  Since:
    1.0

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `HashCodeBuilder()` Uses two hard coded choices for the constants needed to build a `hashCode`.
    `HashCodeBuilder(int initialOddNumber, int multiplierOddNumber)` Two randomly chosen, odd numbers must be passed in.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `HashCodeBuilder` | `append(boolean value)` Append a `hashCode` for a `boolean`.
    `HashCodeBuilder` | `append(boolean[] array)` Append a `hashCode` for a `boolean` array.
    `HashCodeBuilder` | `append(byte value)` Append a `hashCode` for a `byte`.
    `HashCodeBuilder` | `append(byte[] array)` Append a `hashCode` for a `byte` array.
    `HashCodeBuilder` | `append(char value)` Append a `hashCode` for a `char`.
    `HashCodeBuilder` | `append(char[] array)` Append a `hashCode` for a `char` array.
    `HashCodeBuilder` | `append(double value)` Append a `hashCode` for a `double`.
    `HashCodeBuilder` | `append(double[] array)` Append a `hashCode` for a `double` array.
    `HashCodeBuilder` | `append(float value)` Append a `hashCode` for a `float`.
    `HashCodeBuilder` | `append(float[] array)` Append a `hashCode` for a `float` array.
    `HashCodeBuilder` | `append(int value)` Append a `hashCode` for an `int`.
    `HashCodeBuilder` | `append(int[] array)` Append a `hashCode` for an `int` array.
    `HashCodeBuilder` | `append(long value)` Append a `hashCode` for a `long`.
    `HashCodeBuilder` | `append(long[] array)` Append a `hashCode` for a `long` array.
    `HashCodeBuilder` | `append(Object object)` Append a `hashCode` for an `Object`.
    `HashCodeBuilder` | `append(Object[] array)` Append a `hashCode` for an `Object` array.
    `HashCodeBuilder` | `append(short value)` Append a `hashCode` for a `short`.
    `HashCodeBuilder` | `append(short[] array)` Append a `hashCode` for a `short` array.
    `HashCodeBuilder` | `appendSuper(int superHashCode)` Adds the result of super.hashCode() to this builder.
    `Integer` | `build()` Returns the computed `hashCode`.
    `boolean` | `equals(Object obj)` Implements equals using the hash code.
    `int` | `hashCode()` The computed `hashCode` from toHashCode() is returned due to the likelihood of bugs in mis-calling toHashCode() and the unlikeliness of it mattering what the hashCode for HashCodeBuilder itself is.
    `static int` | `reflectionHashCode(int initialNonZeroOddNumber, int multiplierNonZeroOddNumber, Object object)` Uses reflection to build a valid hash code from the fields of `object`.
    `static int` | `reflectionHashCode(int initialNonZeroOddNumber, int multiplierNonZeroOddNumber, Object object, boolean testTransients)` Uses reflection to build a valid hash code from the fields of `object`.
    `static <T> int` | `reflectionHashCode(int initialNonZeroOddNumber, int multiplierNonZeroOddNumber, T object, boolean testTransients, Class<? super T> reflectUpToClass, String... excludeFields)` Uses reflection to build a valid hash code from the fields of `object`.
    `static int` | `reflectionHashCode(Object object, boolean testTransients)` Uses reflection to build a valid hash code from the fields of `object`.
    `static int` | `reflectionHashCode(Object object, Collection<String> excludeFields)` Uses reflection to build a valid hash code from the fields of `object`.
    `static int` | `reflectionHashCode(Object object, String... excludeFields)` Uses reflection to build a valid hash code from the fields of `object`.
    `int` | `toHashCode()` Returns the computed `hashCode`.

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### HashCodeBuilder

          public HashCodeBuilder()

      Uses two hard coded choices for the constants needed to build a `hashCode`.

    - #### HashCodeBuilder

          public HashCodeBuilder(int initialOddNumber,
                                 int multiplierOddNumber)

      Two randomly chosen, odd numbers must be passed in. Ideally these should be different for each class, however this is not vital.

      Prime numbers are preferred, especially for the multiplier.

      Parameters:
        `initialOddNumber` - an odd number used as the initial value
        `multiplierOddNumber` - an odd number used as the multiplier
      Throws:
        `IllegalArgumentException` - if the number is even

  - ### Method Detail

    - #### reflectionHashCode

          public static int reflectionHashCode(int initialNonZeroOddNumber,
                                               int multiplierNonZeroOddNumber,
                                               Object object)

      Uses reflection to build a valid hash code from the fields of `object`.

      It uses `AccessibleObject.setAccessible` to gain access to private fields. This means that it will throw a security exception if run under a security manager, if the permissions are not set up correctly. It is also not as efficient as testing explicitly.

      Transient members will be not be used, as they are likely derived fields, and not part of the value of the `Object`.

      Static fields will not be tested. Superclass fields will be included.

      Two randomly chosen, non-zero, odd numbers must be passed in. Ideally these should be different for each class, however this is not vital. Prime numbers are preferred, especially for the multiplier.

      Parameters:
        `initialNonZeroOddNumber` - a non-zero, odd number used as the initial value. This will be the returned value if no fields are found to include in the hash code
        `multiplierNonZeroOddNumber` - a non-zero, odd number used as the multiplier
        `object` - the Object to create a `hashCode` for
      Returns:
        int hash code
      Throws:
        `NullPointerException` - if the Object is `null`
        `IllegalArgumentException` - if the number is zero or even
      See Also:
        `HashCodeExclude`

    - #### reflectionHashCode

          public static int reflectionHashCode(int initialNonZeroOddNumber,
                                               int multiplierNonZeroOddNumber,
                                               Object object,
                                               boolean testTransients)

      Uses reflection to build a valid hash code from the fields of `object`.

      It uses `AccessibleObject.setAccessible` to gain access to private fields. This means that it will throw a security exception if run under a security manager, if the permissions are not set up correctly. It is also not as efficient as testing explicitly.

      If the TestTransients parameter is set to `true`, transient members will be tested, otherwise they are ignored, as they are likely derived fields, and not part of the value of the `Object`.

      Static fields will not be tested. Superclass fields will be included.

      Two randomly chosen, non-zero, odd numbers must be passed in. Ideally these should be different for each class, however this is not vital. Prime numbers are preferred, especially for the multiplier.

      Parameters:
        `initialNonZeroOddNumber` - a non-zero, odd number used as the initial value. This will be the returned value if no fields are found to include in the hash code
        `multiplierNonZeroOddNumber` - a non-zero, odd number used as the multiplier
        `object` - the Object to create a `hashCode` for
        `testTransients` - whether to include transient fields
      Returns:
        int hash code
      Throws:
        `NullPointerException` - if the Object is `null`
        `IllegalArgumentException` - if the number is zero or even
      See Also:
        `HashCodeExclude`

    - #### reflectionHashCode

          public static <T> int reflectionHashCode(int initialNonZeroOddNumber,
                                                   int multiplierNonZeroOddNumber,
                                                   T object,
                                                   boolean testTransients,
                                                   Class<? super T> reflectUpToClass,
                                                   String... excludeFields)

      Uses reflection to build a valid hash code from the fields of `object`.

      It uses `AccessibleObject.setAccessible` to gain access to private fields. This means that it will throw a security exception if run under a security manager, if the permissions are not set up correctly. It is also not as efficient as testing explicitly.

      If the TestTransients parameter is set to `true`, transient members will be tested, otherwise they are ignored, as they are likely derived fields, and not part of the value of the `Object`.

      Static fields will not be included. Superclass fields will be included up to and including the specified superclass. A null superclass is treated as java.lang.Object.

      Two randomly chosen, non-zero, odd numbers must be passed in. Ideally these should be different for each class, however this is not vital. Prime numbers are preferred, especially for the multiplier.

      Type Parameters:
        `T` - the type of the object involved
      Parameters:
        `initialNonZeroOddNumber` - a non-zero, odd number used as the initial value. This will be the returned value if no fields are found to include in the hash code
        `multiplierNonZeroOddNumber` - a non-zero, odd number used as the multiplier
        `object` - the Object to create a `hashCode` for
        `testTransients` - whether to include transient fields
        `reflectUpToClass` - the superclass to reflect up to (inclusive), may be `null`
        `excludeFields` - array of field names to exclude from use in calculation of hash code
      Returns:
        int hash code
      Throws:
        `NullPointerException` - if the Object is `null`
        `IllegalArgumentException` - if the number is zero or even
      Since:
        2.0
      See Also:
        `HashCodeExclude`

    - #### reflectionHashCode

          public static int reflectionHashCode(Object object,
                                               boolean testTransients)

      Uses reflection to build a valid hash code from the fields of `object`.

      This constructor uses two hard coded choices for the constants needed to build a hash code.

      It uses `AccessibleObject.setAccessible` to gain access to private fields. This means that it will throw a security exception if run under a security manager, if the permissions are not set up correctly. It is also not as efficient as testing explicitly.

      If the TestTransients parameter is set to `true`, transient members will be tested, otherwise they are ignored, as they are likely derived fields, and not part of the value of the `Object`.

      Static fields will not be tested. Superclass fields will be included. If no fields are found to include in the hash code, the result of this method will be constant.

      Parameters:
        `object` - the Object to create a `hashCode` for
        `testTransients` - whether to include transient fields
      Returns:
        int hash code
      Throws:
        `NullPointerException` - if the object is `null`
      See Also:
        `HashCodeExclude`

    - #### reflectionHashCode

          public static int reflectionHashCode(Object object,
                                               Collection<String> excludeFields)

      Uses reflection to build a valid hash code from the fields of `object`.

      This constructor uses two hard coded choices for the constants needed to build a hash code.

      It uses `AccessibleObject.setAccessible` to gain access to private fields. This means that it will throw a security exception if run under a security manager, if the permissions are not set up correctly. It is also not as efficient as testing explicitly.

      Transient members will be not be used, as they are likely derived fields, and not part of the value of the `Object`.

      Static fields will not be tested. Superclass fields will be included. If no fields are found to include in the hash code, the result of this method will be constant.

      Parameters:
        `object` - the Object to create a `hashCode` for
        `excludeFields` - Collection of String field names to exclude from use in calculation of hash code
      Returns:
        int hash code
      Throws:
        `NullPointerException` - if the object is `null`
      See Also:
        `HashCodeExclude`

    - #### reflectionHashCode

          public static int reflectionHashCode(Object object,
                                               String... excludeFields)

      Uses reflection to build a valid hash code from the fields of `object`.

      This constructor uses two hard coded choices for the constants needed to build a hash code.

      It uses `AccessibleObject.setAccessible` to gain access to private fields. This means that it will throw a security exception if run under a security manager, if the permissions are not set up correctly. It is also not as efficient as testing explicitly.

      Transient members will be not be used, as they are likely derived fields, and not part of the value of the `Object`.

      Static fields will not be tested. Superclass fields will be included. If no fields are found to include in the hash code, the result of this method will be constant.

      Parameters:
        `object` - the Object to create a `hashCode` for
        `excludeFields` - array of field names to exclude from use in calculation of hash code
      Returns:
        int hash code
      Throws:
        `NullPointerException` - if the object is `null`
      See Also:
        `HashCodeExclude`

    - #### append

          public HashCodeBuilder append(boolean value)

      Append a `hashCode` for a `boolean`.

      This adds `1` when true, and `0` when false to the `hashCode`.

      This is in contrast to the standard `java.lang.Boolean.hashCode` handling, which computes a `hashCode` value of `1231` for `java.lang.Boolean` instances that represent `true` or `1237` for `java.lang.Boolean` instances that represent `false`.

      This is in accordance with the Effective Java design.

      Parameters:
        `value` - the boolean to add to the `hashCode`
      Returns:
        this

    - #### append

          public HashCodeBuilder append(boolean[] array)

      Append a `hashCode` for a `boolean` array.
      Parameters:
        `array` - the array to add to the `hashCode`
      Returns:
        this

    - #### append

          public HashCodeBuilder append(byte value)

      Append a `hashCode` for a `byte`.
      Parameters:
        `value` - the byte to add to the `hashCode`
      Returns:
        this

    - #### append

          public HashCodeBuilder append(byte[] array)

      Append a `hashCode` for a `byte` array.
      Parameters:
        `array` - the array to add to the `hashCode`
      Returns:
        this

    - #### append

          public HashCodeBuilder append(char value)

      Append a `hashCode` for a `char`.
      Parameters:
        `value` - the char to add to the `hashCode`
      Returns:
        this

    - #### append

          public HashCodeBuilder append(char[] array)

      Append a `hashCode` for a `char` array.
      Parameters:
        `array` - the array to add to the `hashCode`
      Returns:
        this

    - #### append

          public HashCodeBuilder append(double value)

      Append a `hashCode` for a `double`.
      Parameters:
        `value` - the double to add to the `hashCode`
      Returns:
        this

    - #### append

          public HashCodeBuilder append(double[] array)

      Append a `hashCode` for a `double` array.
      Parameters:
        `array` - the array to add to the `hashCode`
      Returns:
        this

    - #### append

          public HashCodeBuilder append(float value)

      Append a `hashCode` for a `float`.
      Parameters:
        `value` - the float to add to the `hashCode`
      Returns:
        this

    - #### append

          public HashCodeBuilder append(float[] array)

      Append a `hashCode` for a `float` array.
      Parameters:
        `array` - the array to add to the `hashCode`
      Returns:
        this

    - #### append

          public HashCodeBuilder append(int value)

      Append a `hashCode` for an `int`.
      Parameters:
        `value` - the int to add to the `hashCode`
      Returns:
        this

    - #### append

          public HashCodeBuilder append(int[] array)

      Append a `hashCode` for an `int` array.
      Parameters:
        `array` - the array to add to the `hashCode`
      Returns:
        this

    - #### append

          public HashCodeBuilder append(long value)

      Append a `hashCode` for a `long`.
      Parameters:
        `value` - the long to add to the `hashCode`
      Returns:
        this

    - #### append

          public HashCodeBuilder append(long[] array)

      Append a `hashCode` for a `long` array.
      Parameters:
        `array` - the array to add to the `hashCode`
      Returns:
        this

    - #### append

          public HashCodeBuilder append(Object object)

      Append a `hashCode` for an `Object`.
      Parameters:
        `object` - the Object to add to the `hashCode`
      Returns:
        this

    - #### append

          public HashCodeBuilder append(Object[] array)

      Append a `hashCode` for an `Object` array.
      Parameters:
        `array` - the array to add to the `hashCode`
      Returns:
        this

    - #### append

          public HashCodeBuilder append(short value)

      Append a `hashCode` for a `short`.
      Parameters:
        `value` - the short to add to the `hashCode`
      Returns:
        this

    - #### append

          public HashCodeBuilder append(short[] array)

      Append a `hashCode` for a `short` array.
      Parameters:
        `array` - the array to add to the `hashCode`
      Returns:
        this

    - #### appendSuper

          public HashCodeBuilder appendSuper(int superHashCode)

      Adds the result of super.hashCode() to this builder.
      Parameters:
        `superHashCode` - the result of calling `super.hashCode()`
      Returns:
        this
      Since:
        2.0

    - #### build

          public Integer build()

      Returns the computed `hashCode`.
      Specified by:
        `build` in interface `Builder<Integer>`
      Returns:
        `hashCode` based on the fields appended
      Since:
        3.0

    - #### equals

          public boolean equals(Object obj)

      Implements equals using the hash code.
      Overrides:
        `equals` in class `Object`
      Since:
        3.13.0

    - #### hashCode

          public int hashCode()

      The computed `hashCode` from toHashCode() is returned due to the likelihood of bugs in mis-calling toHashCode() and the unlikeliness of it mattering what the hashCode for HashCodeBuilder itself is.
      Overrides:
        `hashCode` in class `Object`
      Returns:
        `hashCode` based on the fields appended
      Since:
        2.5

    - #### toHashCode

          public int toHashCode()

      Returns the computed `hashCode`.
      Returns:
        `hashCode` based on the fields appended

Copyright © 2001–2023 The Apache Software Foundation. All rights reserved.